/*
        Program Name : Randoms
        Package Name : LB
        Purpose      : Generate random numbers
        Institution  : Conroy & Conroy Co.
        Date Written : 30-Dec-1998
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 1998 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	These classes are used to generate random numbers.
*/

class TRNG
{
    private: // Instance data...
        int _X ;

    public: // API...
        int Generate() ; // Generate a new random value

        void Randomize() ; // Randomize X

        void Set_X( int _X_ ) ; // Set X

        int X() ; // Return X
};


class TRNG8
{
    private: // Instance data...
        unsigned char _X ;

    public: // API...
        unsigned char Generate() ;
        // Generate a new random value

        void Randomize() ; // Randomize X

        void Set_X( unsigned char _X_ ) ; // Set X

        unsigned char X() ; // Return X
};


class TRNG16
{
    private: // Instance data...
        unsigned short _X ;

    public: // API...
        unsigned short Generate() ;
        // Generate a new random value

        void Randomize() ; // Randomize X

        void Set_X( unsigned short _X_ ) ; // Set X

        unsigned short X() ; // Return X
};


class TRNG32
{
    private: // Instance data...
        unsigned long _X ;

    public: // API...
        unsigned long Generate() ;
        // Generate a new random value

        void Randomize() ; // Randomize X

        void Set_X( unsigned long _X_ ) ; // Set X

        unsigned long X() ; // Return X
};



