unit Linenumb ;


{
        Program Name : LINENUMB
        Package Name : LB
        Purpose      : Standard Line number dialog
        Institution  : Conroy & Conroy Co.
        Date Written : 10-Nov-1992
        Written By   : Alan Conroy
        Version      : 1.3

        Copyright (C) 1992 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This form is the standard Line number dialog.
}

interface

uses // Borland...
     Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, Buttons, Mask, ExtCtrls ;

type
  Tline_Number_Dialog = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Line_Number_Edit: TMaskEdit;
    OK_Button: TBitBtn;
    Cancel_Button: TBitBtn;
    Help_Button: TBitBtn;
    procedure Help_ButtonClick(Sender: TObject);
  public // Public declarations
      function Line_Number : integer ;
  end ;

var Line_Number_Dialog : TLine_Number_Dialog ;

implementation

uses CommonUt ; // Edit

{$R *.DFM}

function TLine_Number_Dialog.Line_Number : integer ;

begin
    if( edit( Line_Number_Edit.Text, -1 ) = '' ) then
    begin
        Line_Number := 0 ;
    end else
    begin
        Line_Number := strtoint( edit( Line_Number_Edit.Text, -1 ) ) ;
    end ;
end ;


procedure Tline_Number_Dialog.Help_ButtonClick( Sender : TObject ) ;

begin
    Application.HelpContext( HelpContext ) ;
end ;



end.
