.RADIX  10
.8086

;              Program Name : IO
;              Package Name : LB
;              Purpose      : IO routine support
;              Institution  : Conroy & Conroy Company
;              Date Written : 04-Apr-86
;              Written By   : Alan Conroy
;              Version      : 9.2-10
;
;	 Copyright (C) 1986 by Alan Conroy.  Released to the public domain.
;
;        *********************************************************
;        *                                                       *
;        *        M O D I F I C A T I O N   H I S T O R Y        *
;        *                                                       *
;        *     DATE      BY             REASON                   *
;        *                                                       *
;        *********************************************************
;
;        *********************************************************
;        *                                                       *
;        *           P R O G R A M   P U R P O S E               *
;        *                                                       *
;        *********************************************************
;
;          This file defines buffers used by various I/O routines.
;

DGroup  GROUP   Data

Data    SEGMENT BYTE

WorkBuff DB     256 DUP (0) ; Work area
WorkBLen DB       0         ; Length of string in work area

InBuff  DB      256 DUP (0) ; Input buffer
InBLen  DB        0         ; Current position in input buffer

OutBuff DB      256 DUP (0) ; Output buffer
OutBLen DB        0         ; Current position in output buffer

CCPOS   DB        0         ; Current position on output line

KBFlags DW        0         ; Flags for console terminal:
                            ;    AND 1 = Output is suspended (XOFFed)
                            ;    AND 2-32768 = Reserved

Data    ENDS
