#if !defined(__TUEC_H)
  #define __TUEC_H
  struct TUEC
  {
      int Facility ;
      int Code ;
  } ;

  class tError_Interface
  {
      public:
          virtual __stdcall int Get_Facility()=0;
          virtual char* __stdcall Get_Name()=0;
          virtual char* __stdcall Translate_Error( int Code )=0;
          virtual __stdcall void Done()=0;
          virtual __stdcall int Facility_Version()=0;
          virtual __stdcall int Version()=0;

          // V1.2 support...
          virtual __stdcall int Severity( int Code )=0;
          virtual __stdcall char* Translate_Error_Ex( int Code, int& Size, int& Typ )=0;
  } ;
#endif

#define UEH_Success = 0 ;
#define UEH_Informational = 1 ;
#define UEH_Warning = 2 ;
#define UEH_Error = 3 ;
#define UEH_Fatal = 4 ;

