{
        Program Name : VT05
        Package Name : CEF
        Purpose      : Generic Video Terminal
        Institution  : Conroy & Conroy Co.
        Date Written : 2-Dec-2006
        Written By   : Alan Conroy
        Version      : 1.0A

	Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        * 20-Jan-2007    EAC         Handle shutdown better.        *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This is a bare-bones video terminal emulator component for CEF.
}

library VT05 ;

uses
  Forms,
  App,
  CEF,
  VT_05 in 'VT_05.pas',
  VT05_main in 'VT05_main.pas' {Main_Form},
  Video_Options_Form in 'Video_Options_Form.pas' {Video_Options_Dialog},
  Send in 'Send.pas' {Send_Dialog};

{$R *.res}

const VT05_Facility = -1 ;

function Facility_Code : integer ; stdcall ;

begin
    Result := VT05_Facility ;
end ;


function Make_Instance( Serial_Number : integer ; UI : TUI_Interface ) : TVT05 ;
    stdcall ;

begin
    Result := TVT05.Create ;
    Result.Initialize( UI ) ;
    Result._Serial_Number := Serial_Number ;
end ;


function Version : longint ;

begin
    Version := 20 ; // Version 2.0
end ;


{$WARNINGS OFF}
exports Facility_Code index 0,
        Make_Instance index 1,
        Version index 2 ;
{$WARNINGS ON}

var F : TForm ;

begin
    Application.Initialize ;
    Application.CreateForm(TForm, F);
    F.Visible := False ;
    { VCL kills the DLL when the first created form is closed, so create this
      form so if the screen is destroyed (by terminating the TVT05
      object), the DLL remains. }
end.
